Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 206893 - app-text/ghostscript-gpl carries internal copy of icclib
Summary: app-text/ghostscript-gpl carries internal copy of icclib
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: New packages (show other bugs)
Hardware: All Linux
: High normal (vote)
Assignee: Printing Team
URL:
Whiteboard:
Keywords:
Depends on: 321997 401853
Blocks: bundled-libs
  Show dependency tree
 
Reported: 2008-01-21 17:36 UTC by Diego Elio Pettenò (RETIRED)
Modified: 2014-02-12 12:24 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Diego Elio Pettenò (RETIRED) gentoo-dev 2008-01-21 17:36:46 UTC
nm -D --defined-only /usr/bin/gs | grep png

This is enough to show the amount of libpng functions present.

Note that they are present both in /usr/bin/gs and in /usr/lib/libgs.so.
Comment 1 Diego Elio Pettenò (RETIRED) gentoo-dev 2008-01-21 17:41:46 UTC
And cartman from Pardus just let me note that there's internal jpeg too. They do use system libraries for those.

Also ships with a copy of jasper, but a modified one to that, so it's not possible to use the system copy of that just yet.
Comment 2 Timo Gurr (RETIRED) gentoo-dev 2008-02-15 15:49:37 UTC
jpeg and libpng are gone in app-text/ghostscript-gpl-8.61-r2.

zlib remains for now since I was not able to successfully compile ghostscript without the internal one yet.
Comment 3 Sune Kloppenborg Jeppesen gentoo-dev 2008-02-15 19:04:28 UTC
Which versions of zlib and libpng is bundled?
Comment 4 Timo Gurr (RETIRED) gentoo-dev 2008-02-15 19:45:38 UTC
(In reply to comment #3)
> Which versions of zlib and libpng is bundled?
> 

zlib seems to be 1.2.3 and libpng 1.2.22.
Comment 5 Sune Kloppenborg Jeppesen gentoo-dev 2008-02-16 12:21:02 UTC
Both seems safe security wise ATM.
Comment 6 Carsten Lohrke (RETIRED) gentoo-dev 2008-03-01 16:56:07 UTC
On a first glance it seems to be a lot worse. ghostscript-gpl comes with a lot of internal libraries such as 

expat, jasper, jbig2dec, icclib

which should be linked dependencies, instead using the internal lib crap. Most disturbing form the maintenance quality pov is that jasper actually was listed as dependency in former ebuilds, but simply removed.
Comment 7 Timo Gurr (RETIRED) gentoo-dev 2008-03-04 21:14:25 UTC
jasper is now also gone thanks to a patch borrowed from Fedora, let's see how it works out. I also rm -rf expat now for the sake of completeness, however I'm unsure if it was used anyway. So the three remaining ones are jbig2dec, icclib and zlib for now.
Comment 8 Timo Gurr (RETIRED) gentoo-dev 2008-08-08 19:35:50 UTC
zlib should be gone now, too in versions >=app-text/ghostscript-gpl-8.63. At least they get rm -rf'd, not exactly sure how to interpret the nm output though.
Comment 9 Samuli Suominen gentoo-dev 2010-06-10 09:01:20 UTC
media-libs/jbig2dec is now in Portage, it would be nice if ghostscript-gpl was patched to use it.
Comment 10 Rafał Mużyło 2010-11-14 19:42:34 UTC
As of 9.00, ghostscript-gpl uses also bundled freetype (due to misunderstanding of configure script) and lcms 1.18.
First one would probably be fixed by 'rm -rf "${S}/freetype"',
if not for use of ft_glyphslot_free_bitmap, which is freetype internal,
 doesn't seem to be an option for fixing the other one, though.
Comment 11 Rafał Mużyło 2010-11-17 12:22:55 UTC
I need to correct myself.
I've placed the blame on internal freetype functions incorrectly.
The real problem lied in configure.ac.

I've contacted upstream and was told that head no longer uses that function anyway
and the configure.ac problem will be fixed too (the fix is actually trivial).

As for lcms, they're using a patched version and in the (hopefully) near future
plan to move to 2.x.
Comment 12 Rafał Mużyło 2011-02-27 03:37:11 UTC
With ghostscript 9.01, situation has cleared a bit, but ebuild needs an adjustment - now simply adding 'rm -rf "${S}/freetype"' in src_prepare is enough to use system freetype.

Situation of lcms seems unchanged though.
Comment 13 Timo Gurr (RETIRED) gentoo-dev 2011-05-10 19:16:17 UTC
Freetype and lcms removed with >=app-text/ghostscript-gpl-9.02, let's see if it causes any problems.
Comment 14 Rafał Mużyło 2011-10-02 19:07:08 UTC
As of 9.04, ghostscript-gpl builds successfully with system copy of jbig2dec, if the internal copy is removed.
Comment 15 Andreas K. Hüttel gentoo-dev 2012-02-01 21:17:23 UTC
(In reply to comment #14)
> As of 9.04, ghostscript-gpl builds successfully with system copy of jbig2dec,
> if the internal copy is removed.

Indeed. Unbundled in 9.04-r6; some keywords had to be dropped temporarily until arches test and keyword media-libs/jbig2dec.
Comment 16 Andreas K. Hüttel gentoo-dev 2012-04-05 19:48:09 UTC
(In reply to comment #15)
> (In reply to comment #14)
> > As of 9.04, ghostscript-gpl builds successfully with system copy of jbig2dec,
> > if the internal copy is removed.
> 
> Indeed. Unbundled in 9.04-r6; some keywords had to be dropped temporarily
> until arches test and keyword media-libs/jbig2dec.

All keywords restored now in 9.05
Comment 17 Andreas K. Hüttel gentoo-dev 2012-05-20 20:32:58 UTC
status update: media-libs/icclib is in the tree now, but so far I have not managed yet to build gs against it.
Comment 18 Timo Gurr (RETIRED) gentoo-dev 2013-08-23 23:30:18 UTC
Bundled OpenJPEG is back for ghostscript-gpl-9.09 as per bug #459216 and the upstream answer http://bugs.ghostscript.com/show_bug.cgi?id=694449.

Bundled CUPS libs are removed as of ghostscript-gpl-9.09.
Comment 19 Timo Gurr (RETIRED) gentoo-dev 2014-02-12 12:24:44 UTC
Recent ghostscript versions (>=9.07) don't ship with an icclib anymore, it has been replaced by lcms{,2}. Upstream commit:

http://git.ghostscript.com/?p=ghostpdl.git;a=commitdiff;h=d8ca80d1cb480702c109414c46e381981c94ddcb

As OpenJPEG now seems to be the last remaining bundled lib and we can't unbundle it (see comment 18) I'm going to close this bug which kind of evolved to a "tracker" bug anyways. So if any new bundled libraries are spotted, please open a new and separate bug for each. Thanks to everyone involved!